"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard").default;

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.StorybookProvider = void 0;

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/for-each"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/keys"));

var React = _interopRequireWildcard(require("react"));

var _testing = require("@redwoodjs/testing");

const StorybookProvider = ({
  storyFn,
  id
}) => {
  const [loading, setLoading] = React.useState(true);
  React.useEffect(() => {
    const init = async () => {
      var _context;

      // Import all the `*.mock.*` files.
      const reqs = require.context('~__REDWOOD__USER_WEB_SRC', true, /.+(mock).(js|ts)$/);

      (0, _forEach.default)(_context = (0, _keys.default)(reqs).call(reqs)).call(_context, r => {
        reqs(r);
      });
      await (0, _testing.startMSW)('browsers');
      (0, _testing.setupRequestHandlers)();
      setLoading(false);
    };

    init();
  }, [id]);

  if (loading) {
    return null;
  } // default to a non-existent user at the beginning of each story


  mockCurrentUser(null);
  return /*#__PURE__*/React.createElement(_testing.MockProviders, null, storyFn());
};

exports.StorybookProvider = StorybookProvider;